#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire3000five4xi.py">
#<abstract4xi abstract = "fires to direction five and to distance 3000"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2five4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2FIVE - COORDINATE SIGNS OF SHOOT2FIVE4XI: (X - ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2five30004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2five30004xi = {
                1: '-1014x826y2699z',
                2: '-1047x1762y2189z',
                3: '-1053x2636y970z',
                4: '-1078x788y2686z',
                5: '-1100x1905y2038z',
                6: '-1140x745y2672z',
                7: '-1150x1723y2169z',
                8: '-1193x2586y941z',
                9: '-1200x698y2658z',
                10: '-1209x1862y2016z',
                11: '-1251x1678y2148z',
                12: '-1259x646y2644z',
                13: '-125x20y2997z',
                14: '-1315x590y2630z',
                15: '-1317x1813y1994z',
                16: '-1331x2528y913z',
                17: '-1351x1627y2127z',
                18: '-1369x530y2616z',
                19: '-140x908y2855z',
                20: '-1419x466y2601z',
                21: '-1422x1757y1971z',
                22: '-1449x1569y2106z',
                23: '-1466x2462y884z',
                24: '-1467x398y2586z',
                25: '-1511x326y2570z',
                26: '-1525x1694y1949z',
                27: '-1544x1506y2084z',
                28: '-1551x250y2555z',
                29: '-156x17y2995z',
                30: '-1588x172y2539z',
                31: '-1598x2390y855z',
                32: '-1620x90y2523z',
                33: '-1626x1626y1926z',
                34: '-1636x1437y2062z',
                35: '-1647x5y2506z',
                36: '-1723x1551y1903z',
                37: '-1725x1362y2041z',
                38: '-1726x2309y827z',
                39: '-1811x1281y2019z',
                40: '-1816x1471y1879z',
                41: '-1850x2222y798z',
                42: '-187x10y2994z',
                43: '-1892x1196y1996z',
                44: '-1906x1385y1856z',
                45: '-194x927y2846z',
                46: '-1969x2128y769z',
                47: '-1970x1105y1974z',
                48: '-1991x1293y1832z',
                49: '-2042x1009y1951z',
                50: '-2072x1196y1808z',
                51: '-2083x2027y740z',
                52: '-2110x908y1928z',
                53: '-212x2019y2208z',
                54: '-2148x1094y1784z',
                55: '-2173x803y1905z',
                56: '-217x1y2992z',
                57: '-2192x1920y711z',
                58: '-2219x987y1760z',
                59: '-2230x694y1882z',
                60: '-2281x581y1858z',
                61: '-2284x876y1736z',
                62: '-2295x1807y681z',
                63: '-2327x464y1835z',
                64: '-2343x761y1711z',
                65: '-2366x344y1811z',
                66: '-2392x1688y652z',
                67: '-2396x642y1686z',
                68: '-2399x222y1787z',
                69: '-2442x519y1662z',
                70: '-2482x1564y623z',
                71: '-2483x393y1637z',
                72: '-249x943y2836z',
                73: '-2506x100y1821z',
                74: '-2516x264y1611z',
                75: '-2542x133y1586z',
                76: '-2561x0y1560z',
                77: '-2566x1435y593z',
                78: '-2643x1301y564z',
                79: '-2712x1164y535z',
                80: '-2774x1022y505z',
                81: '-2829x877y475z',
                82: '-2875x728y446z',
                83: '-2914x578y416z',
                84: '-2944x425y386z',
                85: '-2966x271y357z',
                86: '-2979x115y327z',
                87: '-307x956y2826z',
                88: '-319x1865y2327z',
                89: '-321x2027y2187z',
                90: '-328x2767y1110z',
                91: '-35x11y2999z',
                92: '-367x965y2816z',
                93: '-421x1868y2308z',
                94: '-428x970y2806z',
                95: '-431x2029y2167z',
                96: '-475x2757y1082z',
                97: '-491x971y2795z',
                98: '-524x1866y2289z',
                99: '-542x2024y2146z',
                100: '-555x969y2784z',
                101: '-620x961y2773z',
                102: '-621x2738y1054z',
                103: '-629x1857y2270z',
                104: '-654x2013y2125z',
                105: '-65x17y2999z',
                106: '-686x950y2761z',
                107: '-733x1843y2250z',
                108: '-752x934y2749z',
                109: '-766x1996y2103z',
                110: '-766x2712y1026z',
                111: '-7x2y2999z',
                112: '-818x914y2737z',
                113: '-838x1822y2230z',
                114: '-878x1972y2082z',
                115: '-884x889y2725z',
                116: '-90x886y2864z',
                117: '-910x2678y998z',
                118: '-943x1795y2210z',
                119: '-949x860y2712z',
                120: '-95x20y2998z',
                121: '-989x1942y2060z'}         

#"
#"/>

# ----------------------------------------------------------------------------------------------------------------
#<function4xi function = "fire3000five4xi" usage = "target function for charge30004xi4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# ----------------------------------------------------------------------------------------------------------------
def fire3000five4xi(queue2five, consumer_channel2five, publisher_channel2five):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE3000FIVE4XIFIVE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE3000FIVE4XIFIVE4XI -  QUEUE2FIVE: ", queue2five)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE3000FIVE4XIFIVE4XI -  CONSUMER_CHANNEL2FIVE: ", consumer_channel2five)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE3000FIVE4XIFIVE4XI -  PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE3000FIVE4XIFIVE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2five.put(shot2five30004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE3000FIVE4XIFIVE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE3000FIVE4XIFIVE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE3000FIVE4XIFIVE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2five8shot2five30004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2five8shot2five30004xi</nack2put4xi>" 
            
        publisher_channel2five.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE3000FIVE4XIFIVE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE3000FIVE4XIFIVE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE3000FIVE4XIFIVE4XI - RETURNING QUEUE OBJECT QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi())  
        # 
            
    return queue2five    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire3000five4xi.py                             
# -------------------------------------------------------------------------------------------------                